package be.iminds.ilabt.jfed.restapi.json;

import be.iminds.ilabt.jfed.util.GeniUrn;
import be.iminds.ilabt.util.jsonld.JsonLdObjectsMetaData;
import be.iminds.ilabt.util.jsonld.impl.ForeignIdObjectBuilder;

import java.net.URI;
import java.sql.Timestamp;

@JsonLdObjectsMetaData.JsonLdObjectBuilderInfo(objectClass = SpeaksForCredential.class)
public class SpeaksForCredentialBuilder
        extends ForeignIdObjectBuilder<SpeaksForCredential, SpeaksForCredentialBuilder> {

    private String credentialXml;
    private GeniUrn speaker;
    private GeniUrn speakingFor;
    private Timestamp expire;

    public SpeaksForCredentialBuilder() {

    }

    public SpeaksForCredentialBuilder(SpeaksForCredential orig) {
        super(orig);
        this.credentialXml = orig.getCredentialXml();
        this.speaker = orig.getSpeaker();
        this.speakingFor = orig.getSpeakingFor();
        this.expire = orig.getExpire();
    }

    public SpeaksForCredentialBuilder setCredentialXml(String credentialXml) {
        this.credentialXml = credentialXml;
        return this;
    }

    public SpeaksForCredentialBuilder setSpeaker(GeniUrn speaker) {
        this.speaker = speaker;
        return this;
    }

    public SpeaksForCredentialBuilder setSpeakingFor(GeniUrn speakingFor) {
        this.speakingFor = speakingFor;
        return this;
    }

    public SpeaksForCredentialBuilder setExpire(Timestamp expire) {
        this.expire = expire;
        return this;
    }

    public SpeaksForCredentialBuilder setUri(URI uri) {
        this.uri = uri;
        return this;
    }

    public SpeaksForCredential create() {
        return new SpeaksForCredential(credentialXml, speaker, speakingFor, expire, uri);
    }

    @Override
    public SpeaksForCredential createMinimized(JsonLdObjectsMetaData.Minimization minimization) {
        return new SpeaksForCredential(
                minimization.includeOtherProperties() ? credentialXml : null,
                minimization.includeOtherProperties() ? speaker : null,
                minimization.includeOtherProperties() ? speakingFor : null,
                minimization.includeOtherProperties() ? expire : null,
                minimization.includeId() ? uri : null);
    }

    public String getCredentialXml() { return credentialXml; }
    public GeniUrn getSpeaker() { return speaker; }
    public GeniUrn getSpeakingFor() { return speakingFor; }
    public Timestamp getExpire() { return expire; }
}
